// PoljeT.java - Ispitivanje klase polja graficke korisnicke povrsi.

import usluge.*;
import java.awt.*;
import java.awt.event.*;

public class PoljeT extends Frame {
  
  private Label rez;                            // Oznaka vrste rezultata.
  Kompl2 prvi, drugi, rezult;                   // Operandi i rezultat.
  private final String[] oper =                 // Natpisi dugmadi.
    {"Zbir", "Razlika", "Proizvod", "Kolicnik"};
  
  private PoljeT () {                           // SASTAVLJANJE PROZORA
    super ("Kompleksna aritmetika");
    setBounds (100, 100, 300, 150); setResizable (false);
    addWindowListener (new WindowAdapter () {   // Obrada dogadjaja prozora.
      public void windowClosing (WindowEvent d) { dispose (); }
    });

    Panel plo = new Panel(); add (plo, "West"); // Ploca za oznake podataka.
    plo.setLayout (new GridLayout (3, 1));
    plo.add (new Label ("Prvi"));
    plo.add (new Label ("Drugi"));
    plo.add (rez = new Label ());
    
    add (plo = new Panel (), "Center");         // Ploca za podatke.
    plo.setLayout (new GridLayout (3, 2));
    try {
      TextField re = new TextField (), im = new TextField ();
      plo.add (re); plo.add (im);
      prvi = new Kompl2 (new Polje(re), new Polje (im));
      re = new TextField (); im = new TextField ();
      plo.add (re); plo.add (im);
      drugi = new Kompl2 (new Polje(re), new Polje (im));
      Label r = new Label (), i = new Label ();
      plo.add (r); plo.add (i);
      rezult = new Kompl2 (new Polje(r), new Polje (i));
    } catch (GPoljeNeOdgovara g) {}
   
    add (plo = new Panel (), "South");          // Ploca za dugmad.
    DugmeAkcija osmatrac = new DugmeAkcija ();
    
    for (int i=0; i<oper.length; i++) {
      Button dugme = new Button (oper[i]);
      plo.add (dugme);
      dugme.addActionListener (osmatrac);
    } 
  }

  private class DugmeAkcija implements ActionListener { // Obrada dogadjaja
    public void actionPerformed (ActionEvent d) {       //   dugmadi.
      String op = ((Button)(d.getSource ())).getLabel ();
      rez.setText (op);
      if (op.equals(oper[0]))
        rezult.postavi (prvi.uzmi ().zbir     (drugi.uzmi ()));
      else if (op.equals(oper[1]))
        rezult.postavi (prvi.uzmi ().razlika  (drugi.uzmi ()));
      else if (op.equals(oper[2]))
        rezult.postavi (prvi.uzmi ().proizvod (drugi.uzmi ()));
      else if (op.equals(oper[3]))
        rezult.postavi (prvi.uzmi ().kolicnik (drugi.uzmi ()));
    }
  }
  
  public static void main (String[] varg)               // GLAVNI PROGRAM.
    { new PoljeT ().setVisible (true); }  
}