// SamoposlugaT.java - Ispitivanje rada samoposluge.

import samoposluga.Samoposluga;
import usluge.*;
import java.awt.*;
import java.awt.event.*;

public class SamoposlugaT extends Frame {

  private Samoposluga samoposl;  // Samoposluga koja se obradjuje.
  private Button dgmOtvori  = new Button ("Otvori"),  // Upravljacka
                 dgmZatvori = new Button ("Zatvori"), //   dugmad.
                 dgmUnisti  = new Button ("Unisti");
  
  private SamoposlugaT (String[] vpar, int x, int y) { // SASTAVLJANJE
    setBounds (x, y, 500, 200);                        //   PROZORA:
    addWindowListener (new WindowAdapter () {   // - obrada zatvaranja
      public void windowClosing (WindowEvent d) //   prozora,
        { new Unisti ().start (); }
     });

    Panel ploKomande = new Panel();             // - ploca za upravljacku
    add (ploKomande, "North");                  //   dugmad,
    ploKomande.setBackground (new Color(255, 192, 192));
    ploKomande.add (dgmOtvori );
    ploKomande.add (dgmZatvori);
    ploKomande.add (dgmUnisti );
    DugmeAkcija akcija = new DugmeAkcija ();
    dgmOtvori .addActionListener (akcija);
    dgmZatvori.addActionListener (akcija);
    dgmUnisti .addActionListener (akcija);

    Panel ploUlazi = new Panel ();              // - ploca za ulaze,
    add (ploUlazi, "West");
    ploUlazi.setBackground (new Color(192, 255, 192));

    Panel ploca = new Panel ();                // - ploca za kase i redove,
    add (ploca, "Center");
    ploca.setLayout (new BorderLayout ());
    Panel ploKase = new Panel (); Panel ploRedovi = new Panel ();
    ploca.add (ploKase, "North"); ploca.add (ploRedovi, "Center");
    ploKase.setBackground   (new Color(192, 192, 255));
    ploRedovi.setBackground (new Color(192, 192, 192));
    int brUlaza = Integer.parseInt (vpar[1]),
        brKasa  = Integer.parseInt (vpar[2]);
    
    try {                          // - polja za razne delove samoposluge:
      Label oznKupci = new Label ();                    //   (za broj
      ploKomande.add (oznKupci);                        //    kupaca)
      Polje pKupci = new Polje (oznKupci);

      ploUlazi.setLayout (new GridLayout (brUlaza, 1)); //   (za ulaze)
      Polje[] pUlazi  = new Polje [brUlaza];
      for (int i=0; i<brUlaza; i++) {
        Label oznaka = new Label ();
        ploUlazi.add (oznaka);
        pUlazi[i] = new Polje(oznaka);
      }

      ploKase  .setLayout (new GridLayout (1, brKasa)); //   (za kase i
      ploRedovi.setLayout (new GridLayout (1, brKasa)); //    redove)
      Polje[] pKase   = new Polje [brKasa];
      Polje[] pRedovi = new Polje [brKasa];
      for (int i=0; i<brKasa; i++) {
        Label oznaka = new Label ();
        ploKase.add (oznaka);
        pKase[i]   = new Polje (oznaka);
        TextArea tekst = new TextArea ();
        ploRedovi.add (tekst);
        pRedovi[i] = new Polje (tekst);
      }

      samoposl = new Samoposluga (          // - stvaranje samoposluge
        brUlaza, brKasa,
        Integer.parseInt (vpar[3]),         //   (maxUlaz)
        Integer.parseInt (vpar[4]),         //   (maxKupovina)
        Integer.parseInt (vpar[5]),         //   (maxNaplata)
        pKupci, pUlazi, pKase, pRedovi
      );
      
      setTitle ("Samoposluga " + samoposl.id()); // - postavljanje natpisa.
    } catch (GPoljeNeOdgovara g) {}
  } // konstruktor
  
  class DugmeAkcija implements ActionListener {   // Obrada pritisaka na
    public void actionPerformed (ActionEvent d) { //   upravljacku dugmad.
      Component k = (Component)d.getSource ();
      if (k == dgmOtvori ) samoposl.otvori  ();
      if (k == dgmZatvori) new Zatvori ().start ();
      if (k == dgmUnisti ) new Unisti  ().start ();
    }
  }
  
  private class Zatvori extends Thread { // Nit za zatvaranje samoposluge.
    public void run ()
      { omoguci (false); samoposl.zatvori (); omoguci (true); }
  }
  
  private class Unisti extends Thread {  // Nit za unistavanje samoposluge.
    public void run ()
      { omoguci (false); samoposl.unisti (); dispose (); }
  }
  
  private void omoguci (boolean da) {    // Podesavanje upotrebljivosti
    dgmOtvori .setEnabled (da);          //   upravljacke dugmadi.
    dgmZatvori.setEnabled (da);
    dgmUnisti .setEnabled (da);
  }
  
  public static void main (String[] vpar) {     // Glavni program.
    for (int i=1; i<=Integer.parseInt (vpar[0]); i++)
      new SamoposlugaT (vpar, 50*i, 120*i).setVisible (true);
  }
}