// SlozeniOtpornik.java - Apstraktna klasa slozenih otpornika.

package otpornici;

public abstract class SlozeniOtpornik extends ApstraktniOtpornik {
  
  protected Elem prvi, posl; // Pocetak i kraj liste sadrzanih otpornika.
  
  protected class Elem {                      // Element liste otpornika:
    ApstraktniOtpornik R;                     //   sadrzani otpornik,
    Elem sled;                                //   sledeci element liste,
    Elem (ApstraktniOtpornik r) {             //   inicijalizacija.
      R = r; 
      if (prvi == null) prvi = this;
        else            posl.sled = this;
      posl = this;
    }
  }
  
  public SlozeniOtpornik dodaj (ApstraktniOtpornik r) { // Dodavanje
    new Elem (r);                                       //   otpornika.
    return this;
  }
                                          // Simboli za tekstualni prikaz:
  protected abstract char otv  ();        //   otvorena zagrada,
  protected abstract char oper ();        //   operator,
  protected abstract char zatv ();        //   zatvorena zagrada.
  
  public final String toString () {       // Tekstualni prikaz.
    StringBuffer s = new StringBuffer ();
    s.append (otv ());
    for (Elem tek=prvi; tek!=null; tek=tek.sled) {
      s.append (tek.R);
      if (tek.sled != null) s.append (oper());
    }
    return s.append (zatv()).toString ();
  }
}