// Krug.java - Klasa krugova u ravni koji ne smeju da se preklapaju.

package ravan;

public class Krug {
  
  private static class Elem {         // Element zajednicke liste
    Krug krug; Elem sled;             //   svih krugova.
    Elem (Krug k) { krug = k; sled = prvi; prvi = this; }
  }

  private static Elem prvi = null;    // Zajednicka lista svih krugova.

  private Tacka c; private double r;  // Centar i poluprecnik.

  private Krug () {}                  // Samo za interne potrebe.
                                      // Moze li krug da postoji?
  public static boolean moze (double r, double x, double y) {
    Krug k = new Krug (); k.r = r; k.c = new Tacka (x, y);
    for (Elem tek=prvi; tek!=null; tek=tek.sled)
      if (tek.krug.rastojanje (k) < 0) return false;
    return true;
  }
  
  public Krug (double r, double x, double y) {  // Stvaranje kruga.
    if (! moze (r, x, y)) System.exit (1);
    this.r = r;
    this.c = new Tacka (x, y);
    new Elem (this);
  }

  public void  brisi () {                        // Krug vise nije potreban.
    Elem tek = prvi, preth = null;
    while (tek.krug != this) { preth=tek; tek=tek.sled; };
    if (preth == null) prvi       = tek.sled;
      else             preth.sled = tek.sled;
  }

  public boolean premesti (double x, double y) { // Premestanje kruga.
    if (! moze (r, x, y)) return false;
    c.x = x; c.y = y; return true;
  }

  public boolean pomeri (double dx, double dy) { // Pomeranje kruga.
    if (! moze (r, c.x+dx, c.y+dy)) return false;
    c.x += dx; c.y += dy; return true;
  }

  double rastojanje (Krug k)                  // Rastojanje do drugog kruga.
    { return c.rastojanje (k.c) - r - k.r; }

  public String toString ()                      // Tekstualni prikaz.
    { return "K[" + r + ",(" + c.x + "," + c.y + ")]"; }
}
