// Kasa.java - Klasa kasa samoposluge.

package samoposluga;
import  usluge.Polje;
import  java.awt.Color;

class Kasa extends Thread {

  private static int ukId = 0;  // Poslednje korisceni identifikator.
  private int id = ++ukId;      // Identifikator kase.
  private int maxNaplata;       // Najduze vreme naplacivanja.
  private Samoposluga samoposl; // Vlasnicka samoposluga.
  private Polje polje;          // Poje za prikaz stanja kase.
  private Red red;              // Red ispred kase.
  private boolean kraj = false, radi = true; // Upravljacki indikatori.

  Kasa (Samoposluga samop, int maxNapl, Polje p, Polje pRed) { // Inicijali-
    samoposl = samop; maxNaplata  = maxNapl;                   //   zacija.
    red = new Red (pRed);
    if ((polje = p) != null) {
      polje.komponenta ().setForeground (Color.black);
      polje.pisi ("Kasa" + id);
    }
    start ();
  }

  public void run () {                          // Telo niti.
    while (!kraj) {
      if (!radi) synchronized (this)
        { try { wait (); } catch (InterruptedException e) {} }
    if (kraj) break;
      try {
        Kupac kupac = red.uzmi ();
        if (polje != null) polje.pisi ("Kasa" + id + ": " + kupac.id());
        try { sleep ((long)(Math.random() * maxNaplata)); } 
          catch (InterruptedException e) {}
        kupac.naplaceno ();
        if (polje != null) polje.pisi ("Kasa" + id);
      } catch (InterruptedException e) {}
    }
  }

  synchronized void zatvori () {                // Zatvaranje kase.
    radi = false;
    if (polje != null) polje.komponenta ().setForeground (Color.red);
  }

  synchronized void otvori () {                 // Otvaranje kase.
    if (! radi) {
      radi = true; notify ();
      if (polje != null) polje.komponenta ().setForeground (Color.black);
    }
  }

  synchronized void unisti ()                   // Zavrsetak niti.
    { kraj = true; interrupt (); }

  void staviURed (Kupac kupac)                  // Stavljanje kupca u red.
    { red.stavi (kupac); }
  
  int id () { return id; }              // Dohvatanje identifikatora kase.
}